Index: /LMDZ6/trunk/libf/phylmd/phys_output_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/phys_output_mod.F90	(revision 4055)
+++ /LMDZ6/trunk/libf/phylmd/phys_output_mod.F90	(revision 4056)
@@ -35,6 +35,5 @@
     USE iophy 
     USE dimphy
-    USE infotrac_phy, ONLY: nqtot, nqo, niadv, tracers, type_trac
-    USE strings_mod,  ONLY: maxlen
+    USE infotrac_phy, ONLY: nqtot, tracers, type_trac, niso, ntraciso, maxlen
     USE ioipsl
     USE phys_cal_mod, only : hour, calend
@@ -96,5 +95,5 @@
     CHARACTER(LEN=4), DIMENSION(nlevSTD)  :: clevSTD
     REAL, DIMENSION(nlevSTD)              :: rlevSTD
-    INTEGER                               :: nsrf, k, iq, iiq, iff, i, j, ilev, jq
+    INTEGER                               :: nsrf, k, iq, iff, i, j, ilev, itr, ixt, iiso, izone
     INTEGER                               :: naero
     LOGICAL                               :: ok_veget
@@ -115,6 +114,4 @@
     LOGICAL, DIMENSION(nfiles)            :: phys_out_filestations
 
-    CHARACTER(LEN=50) :: outiso
-    CHARACTER(LEN=20) :: unit
     CHARACTER(LEN=maxlen) :: tnam, lnam, dn
     INTEGER :: flag(nfiles)
@@ -122,15 +119,11 @@
 !!!!!!!!!! stockage dans une region limitee pour chaque fichier !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
     !                 entre [phys_out_lonmin,phys_out_lonmax] et [phys_out_latmin,phys_out_latmax]
-
-    LOGICAL, DIMENSION(nfiles), SAVE  :: phys_out_regfkey       = (/ .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., &
-                                                                     .FALSE., .FALSE., .FALSE., .FALSE., .FALSE. /)
-    REAL, DIMENSION(nfiles), SAVE     :: phys_out_lonmin        = (/ -180., -180., -180., -180., -180., &
-                                                                     -180., -180., -180., -180., -180. /)
-    REAL, DIMENSION(nfiles), SAVE     :: phys_out_lonmax        = (/  180.,  180.,  180.,  180.,  180., &
-                                                                      180.,  180.,  180.,  180.,  180. /)
-    REAL, DIMENSION(nfiles), SAVE     :: phys_out_latmin        = (/  -90.,  -90.,  -90.,  -90.,  -90., &
-                                                                      -90.,  -90.,  -90.,  -90.,  -90. /)
-    REAL, DIMENSION(nfiles), SAVE     :: phys_out_latmax        = (/   90.,   90.,   90.,   90.,   90., &
-                                                                       90.,   90.,   90.,   90.,   90. /)
+    LOGICAL, DIMENSION(nfiles), SAVE :: &
+      phys_out_regfkey = [.FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE., .FALSE.]
+    REAL,    DIMENSION(nfiles), SAVE :: &
+      phys_out_lonmin  = [  -180.,   -180.,   -180.,   -180.,   -180.,   -180.,   -180.,   -180.,   -180.,   -180.], &
+      phys_out_lonmax  = [   180.,    180.,    180.,    180.,    180.,    180.,    180.,    180.,    180.,    180.], &
+      phys_out_latmin  = [   -90.,    -90.,    -90.,    -90.,    -90.,    -90.,    -90.,    -90.,    -90.,    -90.], &
+      phys_out_latmax  = [    90.,     90.,     90.,     90.,     90.,     90.,     90.,     90.,     90.,     90.]
     REAL, DIMENSION(klev,2) :: Ahyb_bounds, Bhyb_bounds
     REAL, DIMENSION(klev+1)   :: lev_index
@@ -169,5 +162,5 @@
     ALLOCATE(o_dtr_dry(nqtot),o_dtr_vdf(nqtot))
 
-    levmax = (/ klev, klev, klev, klev, klev, klev, nlevSTD, nlevSTD, nlevSTD, klev /)
+    levmax = [klev, klev, klev, klev, klev, klev, nlevSTD, nlevSTD, nlevSTD, klev]
 
     phys_out_filenames(1) = 'histmth'
@@ -366,39 +359,16 @@
     CALL wxios_add_vaxis("bnds", 2, (/1.,2./))
 
-     CALL wxios_add_vaxis("Alt", &
+    CALL wxios_add_vaxis("Alt", &
             levmax(iff) - levmin(iff) + 1, pseudoalt)
 
-    IF (NSW.EQ.6) THEN
-!
-!wl1_sun: minimum bound of wavelength (in um)
-!
-      wl1_sun(1)=0.180
-      wl1_sun(2)=0.250
-      wl1_sun(3)=0.440
-      wl1_sun(4)=0.690
-      wl1_sun(5)=1.190
-      wl1_sun(6)=2.380
-!
-!wl2_sun: maximum bound of wavelength (in um)
-!
-      wl2_sun(1)=0.250
-      wl2_sun(2)=0.440
-      wl2_sun(3)=0.690
-      wl2_sun(4)=1.190
-      wl2_sun(5)=2.380
-      wl2_sun(6)=4.000
-!
-    ELSE IF(NSW.EQ.2) THEN
-!
-!wl1_sun: minimum bound of wavelength (in um)
-!
-      wl1_sun(1)=0.250
-      wl1_sun(2)=0.690
-!
-!wl2_sun: maximum bound of wavelength (in um)
-!
-      wl2_sun(1)=0.690
-      wl2_sun(2)=4.000
-    ENDIF
+    ! wl1_sun/wl2_sun: minimum/maximum bound of wavelength (in um)
+    SELECT CASE(NSW)
+      CASE(6)
+        wl1_sun(1:6) = [0.180, 0.250, 0.440, 0.690, 1.190, 2.380]
+        wl2_sun(1:6) = [0.250, 0.440, 0.690, 1.190, 2.380, 4.000]
+      CASE(2)
+        wl1_sun(1:2) = [0.250, 0.690]
+        wl2_sun(1:2) = [0.690, 4.000]
+    END SELECT
 
     DO ISW=1, NSW
@@ -498,41 +468,41 @@
      ENDIF ! clef_files
 
-       IF (nqtot>=nqo+1) THEN
-!
-          DO iq=nqo+1,nqtot 
-            iiq=niadv(iq); jq = iq-nqo
-            dn = 'd'//TRIM(tracers(iiq)%name)//'_'
+          itr = 0
+          DO iq = 1, nqtot 
+            IF(.NOT.tracers(iq)%isAdvected .OR. tracers(iq)%isH2Ofamily) CYCLE
+            itr = itr + 1
+            dn = 'd'//TRIM(tracers(iq)%name)//'_'
 
             flag = [1, 5, 5, 5, 10, 10, 11, 11, 11, 11]
-            lnam = 'Tracer '//TRIM(tracers(iiq)%longName)
-            tnam = TRIM(tracers(iiq)%name); o_trac          (jq) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+            lnam = 'Tracer '//TRIM(tracers(iq)%longName)
+            tnam = TRIM(tracers(iq)%name);  o_trac          (itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+
             flag = [4, 7, 7, 7, 10, 10, 11, 11, 11, 11]
-            lnam = 'Tendance tracer '//TRIM(tracers(iiq)%longName)
-            tnam = TRIM(dn)//'vdf';         o_dtr_vdf       (jq) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+            lnam = 'Tendance tracer '//TRIM(tracers(iq)%longName)
+            tnam = TRIM(dn)//'vdf';         o_dtr_vdf       (itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
 
             flag = [5, 7, 7, 7, 10, 10, 11, 11, 11, 11]
-            tnam = TRIM(dn)//'the';         o_dtr_the       (jq) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
-            tnam = TRIM(dn)//'con';         o_dtr_con       (jq) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+            tnam = TRIM(dn)//'the';         o_dtr_the       (itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+            tnam = TRIM(dn)//'con';         o_dtr_con       (itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
 
             flag = [7, 7, 7, 7, 10, 10, 11, 11, 11, 11]
-            tnam = TRIM(dn)//'lessi_impa';  o_dtr_lessi_impa(jq) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
-            tnam = TRIM(dn)//'lessi_nucl';  o_dtr_lessi_nucl(jq) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
-            tnam = TRIM(dn)//'insc';        o_dtr_insc      (jq) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
-            tnam = TRIM(dn)//'bcscav';      o_dtr_bcscav    (jq) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
-            tnam = TRIM(dn)//'evapls';      o_dtr_evapls    (jq) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
-            tnam = TRIM(dn)//'ls';          o_dtr_ls        (jq) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
-            tnam = TRIM(dn)//'trsp';        o_dtr_trsp      (jq) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
-            tnam = TRIM(dn)//'sscav';       o_dtr_sscav     (jq) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
-            tnam = TRIM(dn)//'sat';         o_dtr_sat       (jq) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
-            tnam = TRIM(dn)//'uscav';       o_dtr_uscav     (jq) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
-
-            lnam = 'tracer tendency dry deposition'//TRIM(tracers(iiq)%longName)
-            tnam = 'cum'//TRIM(dn)//'dry';  o_dtr_dry       (jq) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+            tnam = TRIM(dn)//'lessi_impa';  o_dtr_lessi_impa(itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+            tnam = TRIM(dn)//'lessi_nucl';  o_dtr_lessi_nucl(itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+            tnam = TRIM(dn)//'insc';        o_dtr_insc      (itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+            tnam = TRIM(dn)//'bcscav';      o_dtr_bcscav    (itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+            tnam = TRIM(dn)//'evapls';      o_dtr_evapls    (itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+            tnam = TRIM(dn)//'ls';          o_dtr_ls        (itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+            tnam = TRIM(dn)//'trsp';        o_dtr_trsp      (itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+            tnam = TRIM(dn)//'sscav';       o_dtr_sscav     (itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+            tnam = TRIM(dn)//'sat';         o_dtr_sat       (itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+            tnam = TRIM(dn)//'uscav';       o_dtr_uscav     (itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+
+            lnam = 'tracer tendency dry deposition'//TRIM(tracers(iq)%longName)
+            tnam = 'cum'//TRIM(dn)//'dry';  o_dtr_dry       (itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
 
             flag = [1, 4, 10, 10, 10, 10, 11, 11, 11, 11]
-            lnam = 'Cumulated tracer '//TRIM(tracers(iiq)%longName)
-            tnam = 'cum'//TRIM(tracers(iiq)%name); o_trac_cum(jq)= ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
+            lnam = 'Cumulated tracer '//TRIM(tracers(iq)%longName)
+            tnam = 'cum'//TRIM(tracers(iq)%name); o_trac_cum(itr) = ctrl_out(flag, tnam, lnam, "-", [('',i=1,nfiles)])
           ENDDO
-       ENDIF
 
    ENDDO !  iff
@@ -555,10 +525,9 @@
     ENDIF
 
-!  DO iq=nqo+1,nqtot 
-!    iiq=niadv(iq)
-!    dn = 'd'//TRIM(tracers(iiq)%name)//'_'
-!    WRITE(*,'(a,i1,a,10i3)')'trac(',iiq,')%flag = ',o_trac(iiq)%flag
-!    WRITE(*,'(a,i1,a)')'trac(',iiq,')%tnam = '//TRIM(o_trac(iiq)%name)
-!    WRITE(*,'(a,i1,a)')'trac(',iiq,')%lnam = '//TRIM(o_trac(iiq)%description)
+!  DO iq=1,nqtot
+!    IF(.NOT.tracers(iq)%isAdvected .OR. tracers(iq)%isH2Ofamily) CYCLE
+!    WRITE(*,'(a,i1,a,10i3)')'trac(',iq,')%flag = ',o_trac(iq)%flag
+!    WRITE(*,'(a,i1,a)')'trac(',iq,')%name = '//TRIM(o_trac(iq)%name)
+!    WRITE(*,'(a,i1,a)')'trac(',iq,')%description = '//TRIM(o_trac(iq)%description)
 !  END DO
 
Index: /LMDZ6/trunk/libf/phylmd/phys_output_write_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/phys_output_write_mod.F90	(revision 4055)
+++ /LMDZ6/trunk/libf/phylmd/phys_output_write_mod.F90	(revision 4056)
@@ -25,5 +25,5 @@
 
     USE dimphy, ONLY: klon, klev, klevp1
-    USE infotrac_phy, ONLY: nbtr, nqtot, nqo, type_trac, tracers, niadv
+    USE infotrac_phy, ONLY: nbtr, nqtot, nqo, type_trac, tracers, niso, ntraciso, maxlen
     USE strings_mod,  ONLY: maxlen
     USE mod_phys_lmdz_para, ONLY: is_north_pole_phy,is_south_pole_phy
@@ -198,6 +198,13 @@
          o_map_emis_Anv, o_map_pcld_Anv, o_map_tcld_Anv, &
          o_map_ntot, o_map_hc,o_map_hist,o_map_Cb,o_map_ThCi,o_map_Anv, &
+#ifdef ISO
+! Isotopes
+         o_xtprecip,o_xtplul,o_xtpluc,o_xtovap,o_xtoliq,o_xtcond, &
+         o_xtevap,o_dxtdyn,o_dxtldyn,o_dxtcon,o_dxtlsc,o_dxteva, &
+         o_dxtajs,o_dxtvdf,o_dxtthe, o_dxtch4, &
+         o_dxtprod_nucl,o_dxtcosmo,o_dxtdecroiss, &
+#endif
+! Tropopause
          o_alt_tropo, & 
-! Tropopause
          o_p_tropopause, o_z_tropopause, o_t_tropopause,  &
          o_col_O3_strato, o_col_O3_tropo,                 & 
@@ -254,4 +261,7 @@
          rhlevSTD, O3STD, O3daySTD, uvSTD, vqSTD, vTSTD, wqSTD, vphiSTD, &
          wTSTD, u2STD, v2STD, T2STD, missing_val_nf90, delta_sal, ds_ns, &
+#ifdef ISO
+        xtrain_con, xtsnow_con, xtrain_fall, xtsnow_fall, &
+#endif
          dt_ns, delta_sst
 
@@ -320,4 +330,11 @@
          east_gwstress, west_gwstress, &
          d_q_ch4, pmfd, pmfu, ref_liq, ref_ice, rhwriteSTD, &
+#ifdef ISO
+        xtrain_lsc, xtsnow_lsc, xt_seri, xtl_seri,xts_seri,xtevap, &
+        d_xt_dyn,d_xtl_dyn,d_xt_con,d_xt_vdf,d_xt_ajsb, &
+        d_xt_lsc,d_xt_eva,d_xt_ch4, &
+        d_xt_ajs, d_xt_ajsb, &
+        d_xt_prod_nucl,d_xt_cosmo,d_xt_decroiss, &
+#endif
          ep, epmax_diag, &  ! epmax_cape
          p_tropopause, t_tropopause, z_tropopause
@@ -367,4 +384,7 @@
     USE pbl_surface_mod, ONLY: snow
     USE indice_sol_mod, ONLY: nbsrf
+#ifdef ISO
+    USE isotopes_mod, ONLY: iso_HTO
+#endif
     USE geometry_mod, ONLY: cell_area, latitude_deg, longitude_deg
     USE surface_data, ONLY: type_ocean, version_ocean, ok_veget, landice_opt
@@ -419,5 +439,5 @@
     ! Local
     INTEGER :: itau_w
-    INTEGER :: i, iinit, iinitend=1, iff, iq, iiq, nsrf, k, ll, naero
+    INTEGER :: i, iinit, iinitend=1, iff, iq, nsrf, k, ll, naero
     REAL, DIMENSION (klon) :: zx_tmp_fi2d, zpt_conv2d, wind100m
     REAL, DIMENSION (klon,klev) :: zx_tmp_fi3d, zpt_conv
@@ -439,5 +459,5 @@
 #endif
     REAL, PARAMETER :: un_jour=86400.
-    INTEGER ISW
+    INTEGER :: ISW, itr, ixt, it
     CHARACTER*1 ch1
     CHARACTER(LEN=maxlen) :: varname, dn
@@ -452,7 +472,4 @@
     REAL,DIMENSION(klon,klev) :: z, dz
     REAL,DIMENSION(klon)      :: zrho, zt
-
-    INTEGER :: nqup
-
 
     ! On calcul le nouveau tau:
@@ -511,11 +528,11 @@
           CALL xios_get_handle("fields_strataer_trac_3D", group_handle)
           ! On boucle sur les traceurs pour les ajouter au groupe puis fixer les attributs
-          DO iq=nqo+1, nqtot
-            iiq=niadv(iq)
-            dn = 'd'//TRIM(tracers(iiq)%name)//'_'
-            WRITE (lunout,*) 'XIOS var=', nqo, iq, nqtot, tracers(iiq)%name
+          DO iq = 1, nqtot
+            IF(.NOT.tracers(iq)%isAdvected .OR. tracers(iq)%isH2Ofamily) CYCLE
+            dn = 'd'//TRIM(tracers(iq)%name)//'_'
+            WRITE (lunout,*) 'XIOS var=', nqo, iq, nqtot, tracers(iq)%name
 
             unt = "kg kg-1"
-            varname=trim(tracers(iiq)%name)
+            varname=trim(tracers(iq)%name)
             CALL xios_add_child(group_handle, child, varname)
             CALL xios_set_attr(child, name=varname, unit=unt)
@@ -561,13 +578,13 @@
             CALL xios_add_child(group_handle, child, varname)
             CALL xios_set_attr(child, name=varname, unit=unt)
-          ENDDO
+          END DO
           !On ajoute les variables 2D traceurs par l interface fortran 
           CALL xios_get_handle("fields_strataer_trac_2D", group_handle)
           ! On boucle sur les traceurs pour les ajouter au groupe puis fixer les attributs
-          DO iq=nqo+1, nqtot
-            iiq=niadv(iq)
+          DO iq = 1, nqtot
+            IF(.NOT.tracers(iq)%isAdvected .OR. tracers(iq)%isH2Ofamily) CYCLE
 
             unt = "kg m-2"
-            varname='cum'//trim(tracers(iiq)%name)
+            varname='cum'//trim(tracers(iq)%name)
             WRITE (lunout,*) 'XIOS var=', iq, nqtot, varname
             CALL xios_add_child(group_handle, child, varname)
@@ -575,5 +592,5 @@
 
             unt = "kg m-2 s-1"
-            varname='cumd'//trim(tracers(iiq)%name)//'_dry'
+            varname='cumd'//trim(tracers(iq)%name)//'_dry'
             CALL xios_add_child(group_handle, child, varname)
             CALL xios_set_attr(child, name=varname, unit=unt)
@@ -611,4 +628,5 @@
        ENDIf
        CALL histwrite_phy(o_aire, zx_tmp_fi2d)
+
        IF (vars_defined) THEN
           DO i=1, klon
@@ -2408,39 +2426,47 @@
        IF (iflag_phytrac == 1 ) then
          IF (type_trac == 'lmdz' .OR. type_trac == 'coag') THEN
-           DO iq=nqo+1, nqtot
+           itr = 0
+           DO iq = 1, nqtot
+             IF(tracers(iq)%isH2Ofamily) CYCLE
+             itr = itr + 1
+!            write(*,*) 'phys_output_write_mod 2337: itr=',itr
              !--3D fields
-             CALL histwrite_phy(o_trac(iq-nqo), tr_seri(:,:,iq-nqo))
-             CALL histwrite_phy(o_dtr_vdf(iq-nqo),d_tr_cl(:,:,iq-nqo))
-             CALL histwrite_phy(o_dtr_the(iq-nqo),d_tr_th(:,:,iq-nqo))
-             CALL histwrite_phy(o_dtr_con(iq-nqo),d_tr_cv(:,:,iq-nqo))
-             CALL histwrite_phy(o_dtr_lessi_impa(iq-nqo),d_tr_lessi_impa(:,:,iq-nqo))
-             CALL histwrite_phy(o_dtr_lessi_nucl(iq-nqo),d_tr_lessi_nucl(:,:,iq-nqo))
-             CALL histwrite_phy(o_dtr_insc(iq-nqo),d_tr_insc(:,:,iq-nqo))
-             CALL histwrite_phy(o_dtr_bcscav(iq-nqo),d_tr_bcscav(:,:,iq-nqo))
-             CALL histwrite_phy(o_dtr_evapls(iq-nqo),d_tr_evapls(:,:,iq-nqo))
-             CALL histwrite_phy(o_dtr_ls(iq-nqo),d_tr_ls(:,:,iq-nqo))
-             CALL histwrite_phy(o_dtr_trsp(iq-nqo),d_tr_trsp(:,:,iq-nqo))
-             CALL histwrite_phy(o_dtr_sscav(iq-nqo),d_tr_sscav(:,:,iq-nqo))
-             CALL histwrite_phy(o_dtr_sat(iq-nqo),d_tr_sat(:,:,iq-nqo))
-             CALL histwrite_phy(o_dtr_uscav(iq-nqo),d_tr_uscav(:,:,iq-nqo))
+             CALL histwrite_phy(o_trac(itr), tr_seri(:,:,itr))
+             CALL histwrite_phy(o_dtr_vdf(itr),d_tr_cl(:,:,itr))
+             CALL histwrite_phy(o_dtr_the(itr),d_tr_th(:,:,itr))
+             CALL histwrite_phy(o_dtr_con(itr),d_tr_cv(:,:,itr))
+             CALL histwrite_phy(o_dtr_lessi_impa(itr),d_tr_lessi_impa(:,:,itr))
+             CALL histwrite_phy(o_dtr_lessi_nucl(itr),d_tr_lessi_nucl(:,:,itr))
+             CALL histwrite_phy(o_dtr_insc(itr),d_tr_insc(:,:,itr))
+             CALL histwrite_phy(o_dtr_bcscav(itr),d_tr_bcscav(:,:,itr))
+             CALL histwrite_phy(o_dtr_evapls(itr),d_tr_evapls(:,:,itr))
+             CALL histwrite_phy(o_dtr_ls(itr),d_tr_ls(:,:,itr))
+             CALL histwrite_phy(o_dtr_trsp(itr),d_tr_trsp(:,:,itr))
+             CALL histwrite_phy(o_dtr_sscav(itr),d_tr_sscav(:,:,itr))
+             CALL histwrite_phy(o_dtr_sat(itr),d_tr_sat(:,:,itr))
+             CALL histwrite_phy(o_dtr_uscav(itr),d_tr_uscav(:,:,itr))
             !--2D fields
-             CALL histwrite_phy(o_dtr_dry(iq-nqo), flux_tr_dry(:,iq-nqo))
+             CALL histwrite_phy(o_dtr_dry(itr), flux_tr_dry(:,itr))
              zx_tmp_fi2d=0.
              IF (vars_defined) THEN
                 DO k=1,klev
-                   zx_tmp_fi2d(:)=zx_tmp_fi2d(:)+zmasse(:,k)*tr_seri(:,k,iq-nqo)
+                   zx_tmp_fi2d(:)=zx_tmp_fi2d(:)+zmasse(:,k)*tr_seri(:,k,itr)
                 ENDDO
              ENDIF
-             CALL histwrite_phy(o_trac_cum(iq-nqo), zx_tmp_fi2d)
+             CALL histwrite_phy(o_trac_cum(itr), zx_tmp_fi2d)
            ENDDO !--iq
          ENDIF   !--type_trac
 !
          IF (type_trac == 'co2i') THEN
-           DO iq=nqo+1, nqtot
+           itr = 0
+           DO iq = 1, nqtot
+             IF(tracers(iq)%isH2Ofamily) CYCLE
+             itr = itr + 1
+!            write(*,*) 'phys_output_write_mod 2370: itr=',itr
              !--3D fields
-             CALL histwrite_phy(o_trac(iq-nqo), tr_seri(:,:,iq-nqo))
-             CALL histwrite_phy(o_dtr_vdf(iq-nqo),d_tr_cl(:,:,iq-nqo))
-             CALL histwrite_phy(o_dtr_the(iq-nqo),d_tr_th(:,:,iq-nqo))
-             CALL histwrite_phy(o_dtr_con(iq-nqo),d_tr_cv(:,:,iq-nqo))
+             CALL histwrite_phy(o_trac(itr), tr_seri(:,:,itr))
+             CALL histwrite_phy(o_dtr_vdf(itr),d_tr_cl(:,:,itr))
+             CALL histwrite_phy(o_dtr_the(itr),d_tr_th(:,:,itr))
+             CALL histwrite_phy(o_dtr_con(itr),d_tr_cv(:,:,itr))
              !--2D fields
              !--CO2 burden
@@ -2448,8 +2474,8 @@
              IF (vars_defined) THEN
                 DO k=1,klev
-                   zx_tmp_fi2d(:)=zx_tmp_fi2d(:)+zmasse(:,k)*tr_seri(:,k,iq-nqo)
+                   zx_tmp_fi2d(:)=zx_tmp_fi2d(:)+zmasse(:,k)*tr_seri(:,k,itr)
                 ENDDO
              ENDIF
-             CALL histwrite_phy(o_trac_cum(iq-nqo), zx_tmp_fi2d)
+             CALL histwrite_phy(o_trac_cum(itr), zx_tmp_fi2d)
            ENDDO !--iq
            !--CO2 net fluxes
@@ -2463,11 +2489,13 @@
 
          IF (type_trac == 'inco') THEN
-           nqup = nqo+1
-           DO iq=nqo+1, nqup
+           DO iq = 1, nqtot
+             IF(tracers(iq)%isH2Ofamily .OR. .NOT.tracers(iq)%isAdvected) CYCLE
+             itr = itr+1
+             IF(tracers(iq)%component /= 'co2i') CYCLE
              !--3D fields
-             CALL histwrite_phy(o_trac(iq-nqo), tr_seri(:,:,iq-nqo))
-             CALL histwrite_phy(o_dtr_vdf(iq-nqo),d_tr_cl(:,:,iq-nqo))
-             CALL histwrite_phy(o_dtr_the(iq-nqo),d_tr_th(:,:,iq-nqo))
-             CALL histwrite_phy(o_dtr_con(iq-nqo),d_tr_cv(:,:,iq-nqo))
+             CALL histwrite_phy(o_trac   (itr),tr_seri(:,:,itr))
+             CALL histwrite_phy(o_dtr_vdf(itr),d_tr_cl(:,:,itr))
+             CALL histwrite_phy(o_dtr_the(itr),d_tr_th(:,:,itr))
+             CALL histwrite_phy(o_dtr_con(itr),d_tr_cv(:,:,itr))
              !--2D fields
              !--CO2 burden
@@ -2475,8 +2503,8 @@
              IF (vars_defined) THEN
                 DO k=1,klev
-                   zx_tmp_fi2d(:)=zx_tmp_fi2d(:)+zmasse(:,k)*tr_seri(:,k,iq-nqo)
+                   zx_tmp_fi2d(:)=zx_tmp_fi2d(:)+zmasse(:,k)*tr_seri(:,k,itr)
                 ENDDO
              ENDIF
-             CALL histwrite_phy(o_trac_cum(iq-nqo), zx_tmp_fi2d)
+             CALL histwrite_phy(o_trac_cum(itr), zx_tmp_fi2d)
            ENDDO !--iq
            !--CO2 net fluxes
@@ -2504,4 +2532,62 @@
        end if
 
+#ifdef ISO
+    do ixt=1,ntraciso
+!        write(*,*) 'ixt'
+        IF (vars_defined) zx_tmp_fi2d(:) = xtrain_fall(ixt,:) + xtsnow_fall(ixt,:)
+        CALL histwrite_phy(o_xtprecip(ixt), zx_tmp_fi2d)
+
+        IF (vars_defined) zx_tmp_fi2d(:) = xtrain_lsc(ixt,:) + xtsnow_lsc(ixt,:)
+        CALL histwrite_phy(o_xtplul(ixt), zx_tmp_fi2d)
+
+        IF (vars_defined) zx_tmp_fi2d(:) = xtrain_con(ixt,:) + xtsnow_con(ixt,:)
+        CALL histwrite_phy(o_xtpluc(ixt), zx_tmp_fi2d)
+        CALL histwrite_phy(o_xtevap(ixt),   xtevap(ixt,:))
+        CALL histwrite_phy(o_xtovap(ixt),  xt_seri(ixt,:,:))
+        CALL histwrite_phy(o_xtoliq(ixt), xtl_seri(ixt,:,:))
+
+        IF (vars_defined) zx_tmp_fi3d(:,:)=xtl_seri(ixt,:,:)+xts_seri(ixt,:,:)
+        CALL histwrite_phy(o_xtcond(ixt), zx_tmp_fi3d)
+        CALL histwrite_phy(o_dxtdyn(ixt),   d_xt_dyn(ixt,:,:))
+        CALL histwrite_phy(o_dxtldyn(ixt), d_xtl_dyn(ixt,:,:))
+
+        IF (vars_defined) zx_tmp_fi3d(:,:)=d_xt_con(ixt,:,:)/pdtphys
+        CALL histwrite_phy(o_dxtcon(ixt), zx_tmp_fi3d)
+
+        IF (vars_defined) zx_tmp_fi3d(:,:)=d_xt_lsc(ixt,:,:)/pdtphys
+        CALL histwrite_phy(o_dxtlsc(ixt), zx_tmp_fi3d)
+
+        IF (vars_defined) zx_tmp_fi3d(:,:)=d_xt_eva(ixt,:,:)/pdtphys
+        CALL histwrite_phy(o_dxteva(ixt), zx_tmp_fi3d)
+
+        IF (vars_defined) zx_tmp_fi3d(:,:)=d_xt_vdf(ixt,:,:)/pdtphys
+        CALL histwrite_phy(o_dxtvdf(ixt), zx_tmp_fi3d)
+
+        IF (vars_defined) zx_tmp_fi3d(:,:)=d_xt_ajsb(ixt,:,:)/pdtphys
+        CALL histwrite_phy(o_dxtajs(ixt), zx_tmp_fi3d)
+
+        IF (vars_defined) zx_tmp_fi3d(:,:)=(d_xt_ajs(ixt,:,:)-d_xt_ajsb(ixt,:,:))/pdtphys
+        CALL histwrite_phy(o_dxtthe(ixt), zx_tmp_fi3d)
+
+        IF (ok_qch4) THEN
+          IF (vars_defined) zx_tmp_fi3d(:,:)=d_xt_ch4(ixt,:,:)/pdtphys
+          CALL histwrite_phy(o_dxtch4(ixt), zx_tmp_fi3d)
+        END IF
+
+        IF (ixt == iso_HTO) THEN
+          IF (vars_defined) zx_tmp_fi3d(:,:)=d_xt_prod_nucl(ixt,:,:)/pdtphys
+          CALL histwrite_phy(o_dxtprod_nucl(ixt), zx_tmp_fi3d)
+
+          IF (vars_defined) zx_tmp_fi3d(:,:)=d_xt_cosmo(ixt,:,:)/pdtphys
+          CALL histwrite_phy(o_dxtcosmo(ixt), zx_tmp_fi3d)
+
+          IF (vars_defined) zx_tmp_fi3d(:,:)=d_xt_decroiss(ixt,:,:)/pdtphys
+          CALL histwrite_phy(o_dxtdecroiss(ixt), zx_tmp_fi3d)
+        END IF
+
+    !write(*,*) 'phys_output_write_mod 2531'
+    enddo !do ixt=1,ntraciso    
+#endif
+
        IF (.NOT.vars_defined) THEN
           !$OMP MASTER
Index: /LMDZ6/trunk/libf/phylmd/physiq_mod.F90
===================================================================
--- /LMDZ6/trunk/libf/phylmd/physiq_mod.F90	(revision 4055)
+++ /LMDZ6/trunk/libf/phylmd/physiq_mod.F90	(revision 4056)
@@ -39,5 +39,7 @@
     USE ioipsl_getin_p_mod, ONLY : getin_p
     USE indice_sol_mod
-    USE infotrac_phy, ONLY: nqtot, nbtr, nqo, type_trac, nqCO2
+    USE infotrac_phy, ONLY: nqtot, nbtr, nqo, tracers, type_trac, nqCO2
+    USE readTracFiles_mod, ONLY: phases_sep
+    USE strings_mod,  ONLY: strIdx
     USE iophy
     USE limit_read_mod, ONLY : init_limit_read
@@ -146,4 +148,6 @@
        !
        d_t_vdf,d_q_vdf,d_u_vdf,d_v_vdf,d_t_diss, &
+       d_t_vdf_x, d_t_vdf_w, &
+       d_q_vdf_x, d_q_vdf_w, &
        d_ts, &
        !
@@ -218,6 +222,4 @@
        zxfluxlat_x, zxfluxlat_w, &
        !
-       d_t_vdf_x, d_t_vdf_w, &
-       d_q_vdf_x, d_q_vdf_w, &
        pbl_tke_input, tke_dissip, l_mix, wprime,&
        t_therm, q_therm, u_therm, v_therm, &
@@ -356,5 +358,5 @@
     LOGICAL, SAVE :: ok_volcan ! pour activer les diagnostics volcaniques
     !$OMP THREADPRIVATE(ok_volcan)
-    INTEGER, SAVE :: flag_volc_surfstrat ! pour imposer le cool/heat rate à la surf ou dans la strato 
+    INTEGER, SAVE :: flag_volc_surfstrat ! pour imposer le cool/heat rate à la surf/strato
     !$OMP THREADPRIVATE(flag_volc_surfstrat)
     LOGICAL ok_cvl  ! pour activer le nouveau driver pour convection KE
@@ -854,5 +856,5 @@
     real zqsat(klon,klev)
     !
-    INTEGER i, k, iq, j, nsrf, ll, l
+    INTEGER i, k, iq, j, nsrf, ll, l, itr
     !
     REAL t_coup
@@ -1035,5 +1037,5 @@
 
     CHARACTER (LEN=20) :: modname='physiq_mod'
-    CHARACTER*80 message, abort_message
+    CHARACTER*80 abort_message
     LOGICAL, SAVE ::  ok_sync, ok_sync_omp
     !$OMP THREADPRIVATE(ok_sync)
@@ -1363,5 +1365,5 @@
          iflag_phytrac = 1
        ENDIF
-#endif	
+#endif
        nvm_lmdz = 13
        CALL getin_p('NVM',nvm_lmdz)
@@ -2230,22 +2232,20 @@
 
     tke0(:,:)=pbl_tke(:,:,is_ave)
-    !CR:Nombre de traceurs de l'eau: nqo
-    !  IF (nqtot.GE.3) THEN
-    IF (nqtot.GE.(nqo+1)) THEN
-       !     DO iq = 3, nqtot        
-       DO iq = nqo+1, nqtot  
+    IF (nqtot > nqo) THEN
+       ! water isotopes are not included in tr_seri
+       itr = 0
+       DO iq = 1, nqtot
+         IF(tracers(iq)%isH2Ofamily) CYCLE
+         itr = itr+1
           DO  k = 1, klev
              DO  i = 1, klon
-                !              tr_seri(i,k,iq-2) = qx(i,k,iq)
-                tr_seri(i,k,iq-nqo) = qx(i,k,iq)
+                tr_seri(i,k,itr) = qx(i,k,iq)
              ENDDO
           ENDDO
        ENDDO
     ELSE
-       DO k = 1, klev
-          DO i = 1, klon
-             tr_seri(i,k,1) = 0.0
-          ENDDO
-       ENDDO
+! DC: make sure the final "1" index was meant for 1st H2O phase (vapor) !!!
+!       tr_seri(:,:,strIdx(tracers(:)%name,'H2O'//phases_sep//'g')) = 0.0
+       tr_seri(:,:,strIdx(tracers(:)%name,'H2Ov')) = 0.0
     ENDIF
 !
@@ -2254,7 +2254,10 @@
     IF (debut) THEN
       WRITE(lunout,*)' WARNING: tr_ancien initialised to tr_seri'
-      DO iq = nqo+1, nqtot
-           tr_ancien(:,:,iq-nqo)=tr_seri(:,:,iq-nqo)
-      ENDDO
+       itr = 0
+       do iq = 1, nqtot
+         IF(tracers(iq)%isH2Ofamily) CYCLE
+         itr = itr+1
+         tr_ancien(:,:,itr)=tr_seri(:,:,itr)       
+       enddo
     ENDIF
     !
@@ -2287,9 +2290,5 @@
        d_qs_dyn2d(:)=(zx_tmp_fi2d(:)-prsw_ancien(:))/phys_tstep
        ! !! RomP >>>   td dyn traceur
-       IF (nqtot.GT.nqo) THEN     ! jyg
-          DO iq = nqo+1, nqtot      ! jyg
-              d_tr_dyn(:,:,iq-nqo)=(tr_seri(:,:,iq-nqo)-tr_ancien(:,:,iq-nqo))/phys_tstep ! jyg
-          ENDDO
-       ENDIF
+       IF (nqtot > nqo) d_tr_dyn(:,:,:)=(tr_seri(:,:,:)-tr_ancien(:,:,:))/phys_tstep
        ! !! RomP <<<
     ELSE
@@ -2304,9 +2303,5 @@
        d_qs_dyn2d(:) = 0.0
        ! !! RomP >>>   td dyn traceur
-       IF (nqtot.GT.nqo) THEN                                       ! jyg
-          DO iq = nqo+1, nqtot                                      ! jyg
-              d_tr_dyn(:,:,iq-nqo)= 0.0                             ! jyg
-          ENDDO
-       ENDIF
+       IF (nqtot > nqo) d_tr_dyn(:,:,:)= 0.0
        ! !! RomP <<<
        ancien_ok = .TRUE.
@@ -2589,5 +2584,5 @@
             debut,     lafin, &
             longitude_deg, latitude_deg, rugoro,  zrmu0,      &
-             sollwdown,    cldt,      &
+            sollwdown,    cldt,      &
             rain_fall, snow_fall, solsw,   solswfdiff, sollw,     &
             gustiness,                                &
@@ -2857,5 +2852,5 @@
          ENDDO
        ELSE
-               t_w(:,:) = t_seri(:,:)
+                t_w(:,:) = t_seri(:,:)
                 q_w(:,:) = q_seri(:,:)
                 t_x(:,:) = t_seri(:,:)
@@ -3073,5 +3068,12 @@
 
        DO i = 1, klon
-          ema_pcb(i)  = paprs(i,ibas_con(i))
+          ! C Risi modif: pour éviter pb de dépassement d'indice dans les cas
+          ! où i n'est pas un point convectif et donc ibas_con(i)=0
+          ! c'est un pb indépendant des isotopes
+          if (ibas_con(i) > 0) then
+             ema_pcb(i)  = paprs(i,ibas_con(i))
+          else
+             ema_pcb(i)  = 0.0
+          endif
        ENDDO
        DO i = 1, klon
@@ -3504,5 +3506,4 @@
     wprime_ave(:,:)=0.
 
-
     DO nsrf = 1, nbsrf
        DO i = 1, klon
@@ -3512,5 +3513,4 @@
        ENDDO
     ENDDO
-
 
     CALL  calcratqs(klon,klev,prt_level,lunout,        &
@@ -3530,4 +3530,5 @@
        print *,'itap, ->fisrtilp ',itap
     ENDIF
+    !
 
     picefra(:,:)=0.
@@ -3556,4 +3557,5 @@
          iflag_ice_thermo)
     ENDIF
+    !
     WHERE (rain_lsc < 0) rain_lsc = 0.
     WHERE (snow_lsc < 0) snow_lsc = 0.
@@ -4267,5 +4269,17 @@
  
 #ifndef CPP_XIOS
-
+          !--OB 30/05/2016 modified 21/10/2016
+          !--here we return swaero_diag and dryaod_diag to FALSE
+          !--and histdef will switch it back to TRUE if necessary
+          !--this is necessary to get the right swaero at first step
+          !--but only in the case of no XIOS as XIOS is covered elsewhere 
+          IF (debut) swaerofree_diag = .FALSE.
+          IF (debut) swaero_diag = .FALSE.
+          IF (debut) dryaod_diag = .FALSE.
+          !--IM 15/09/2017 here we return ok_4xCO2atm to FALSE
+          !--as for swaero_diag, see above
+          IF (debut) ok_4xCO2atm = .FALSE.
+
+          !
           !IM 2eme calcul radiatif pour le cas perturbe ou au moins un
           !IM des taux doit etre different du taux actuel
@@ -5052,13 +5066,12 @@
     ENDDO
     !
-    !CR: nb de traceurs eau: nqo
-    !  IF (nqtot.GE.3) THEN
-    IF (nqtot.GE.(nqo+1)) THEN
-       !     DO iq = 3, nqtot
-       DO iq = nqo+1, nqtot
+    IF (nqtot > nqo+1) THEN
+       itr = 0
+       DO iq = 1, nqtot
+          IF(tracers(iq)%isH2Ofamily) CYCLE
+          itr = itr+1
           DO  k = 1, klev
              DO  i = 1, klon
-                ! d_qx(i,k,iq) = ( tr_seri(i,k,iq-2) - qx(i,k,iq) ) / phys_tstep
-                d_qx(i,k,iq) = ( tr_seri(i,k,iq-nqo) - qx(i,k,iq) ) / phys_tstep
+                d_qx(i,k,iq) = ( tr_seri(i,k,itr) - qx(i,k,iq) ) / phys_tstep
              ENDDO
           ENDDO
@@ -5101,10 +5114,5 @@
     CALL water_int(klon,klev,qs_ancien,zmasse,prsw_ancien)
     ! !! RomP >>>
-    !CR: nb de traceurs eau: nqo
-    IF (nqtot.GT.nqo) THEN
-       DO iq = nqo+1, nqtot
-          tr_ancien(:,:,iq-nqo) = tr_seri(:,:,iq-nqo)
-       ENDDO
-    ENDIF
+    IF (nqtot > nqo) tr_ancien(:,:,:) = tr_seri(:,:,:)
     ! !! RomP <<<
     !==========================================================================
